/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#define FE_FCO_DEBUG		FALSE
#define FE_FCO_EDIT_DEBUG	FALSE
#define FE_FCO_OUTPUT_DEBUG	FALSE

#include "operator/operator.pmh"

using namespace fe;

void FollicleOp::initialize(void)
{
	catalog<String>("icon")="FE_alpha";

	//* page Data

	//* TODO sync to id, uv
	catalog<String>("syncMode")="index";
	catalog<String>("syncMode","label")="Sync To";
	catalog<String>("syncMode","choice:0")="index";
	catalog<String>("syncMode","label:0")="Index";
	catalog<String>("syncMode","choice:1")="location";
	catalog<String>("syncMode","label:1")="Location";
	catalog<bool>("syncMode","joined")=true;
	catalog<String>("syncMode","page")="Data";

	catalog<String>("snapMode")="location";
	catalog<String>("snapMode","label")="Snap To";
	catalog<String>("snapMode","choice:0")="location";
	catalog<String>("snapMode","label:0")="Location";
	catalog<String>("snapMode","choice:1")="uv";
	catalog<String>("snapMode","label:1")="UV";
	catalog<String>("snapMode","page")="Data";
	catalog<String>("snapMode","hint")=
			"Make changes by snapping to the surface in world space"
			" or by following UV coordinates.";

//	catalogMoveToEnd("IdAttr");
	catalogRemove("IdAttr");

	catalog<bool>("affectAttribute")=false;
	catalog<String>("affectAttribute","label")="Paint";
	catalog<bool>("affectAttribute","joined")=true;
	catalog<String>("affectAttribute","page")="Data";

	catalog<String>("attribute");
	catalog<String>("attribute","label")="Attribute";
	catalog<String>("attribute","enabler")="affectAttribute";
	catalog<String>("attribute","page")="Data";

	catalog<String>("hideGroup")="hide";
	catalog<String>("hideGroup","label")="Hide To Group";
	catalog<String>("hideGroup","page")="Data";
	catalog<String>("hideGroup","hint")=
			"Put all hidden points in this new group.";

	//* page Edit
	catalog<String>("modifyMode")="drag";
	catalog<String>("modifyMode","label")="Modification";
	catalog<String>("modifyMode","choice:0")="none";
	catalog<String>("modifyMode","label:0")="None";
	catalog<String>("modifyMode","choice:1")="drag";
	catalog<String>("modifyMode","label:1")="Drag Positions";
	catalog<String>("modifyMode","choice:2")="paint";
	catalog<String>("modifyMode","label:2")="Paint Values";
	catalog<bool>("modifyMode","joined")=true;
	catalog<String>("modifyMode","page")="Edit";

	catalog<String>("action")="replace";
	catalog<String>("action","label")="Paint Action";
	catalog<String>("action","choice:0")="replace";
	catalog<String>("action","label:0")="Replace/Restore";
	catalog<String>("action","choice:1")="smooth";
	catalog<String>("action","label:1")="Smooth/Saturate";
	catalog<String>("action","choice:2")="add";
	catalog<String>("action","label:2")="Add/Subtract";
	catalog<String>("action","choice:3")="scale";
	catalog<String>("action","label:3")="Scale/InvScale";
	catalog<String>("action","page")="Edit";
	catalog<String>("action","IO")="input output";

	catalog<Real>("opacity")=0.1;
	catalog<Real>("opacity","high")=1.0;
	catalog<String>("opacity","label")="Opacity";
	catalog<String>("opacity","page")="Edit";
	catalog<bool>("opacity","joined")=true;

	catalog<SpatialVector>("mask")=SpatialVector(1.0,1.0,1.0);
	catalog<String>("mask","label")="Mask";
	catalog<String>("mask","page")="Edit";

	catalog<SpatialVector>("replacement")=SpatialVector(1.0,1.0,1.0);
	catalog<String>("replacement","label")="Replacement";
	catalog<String>("replacement","page")="Edit";
	catalog<bool>("replacement","joined")=true;

	catalog<Real>("scalar")=1.0;
	catalog<Real>("scalar","low")=0.0;
	catalog<Real>("scalar","high")=1.0;
	catalog<Real>("scalar","min")= -1e6;
	catalog<Real>("scalar","max")=1e6;
	catalog<String>("scalar","label")="Scaled";
	catalog<String>("scalar","page")="Edit";

	//* TODO clamp min,max

	//* TODO display min,max

	catalog<Real>("pickRadius")=0.1;
	catalog<Real>("pickRadius","high")=1.0;
	catalog<Real>("pickRadius","max")=1e3;
	catalog<String>("pickRadius","label")="Pick Radius";
	catalog<String>("pickRadius","IO")="input output";
	catalog<bool>("pickRadius","joined")=true;
	catalog<String>("pickRadius","page")="Edit";
	catalog<String>("pickRadius","hint")="Outer scope of area select.";

	catalog<Real>("falloff")=0.5;
	catalog<Real>("falloff","max")=1.0;
	catalog<String>("falloff","label")="Falloff";
	catalog<String>("falloff","IO")="input output";
	catalog<String>("falloff","page")="Edit";
	catalog<String>("falloff","hint")="Falloff portion of area select.";

	catalog<Real>("fuzzy")=0.0;
	catalog<Real>("fuzzy","max")=1.0;
	catalog<String>("fuzzy","label")="Fuzzy Weights";
	catalog<String>("fuzzy","page")="Edit";
	catalog<String>("fuzzy","hint")="Selection randomness.";

	//* page Display
	catalog<Real>("singleRadius")=0.1;
	catalog<String>("singleRadius","label")="Single Radius";
	catalog<String>("singleRadius","page")="Display";
	catalog<String>("singleRadius","hint")=
			"Drawn radius during single select.";

	catalog<I32>("lineWidth")=2;
	catalog<I32>("lineWidth","min")=1;
	catalog<I32>("lineWidth","max")=10;
	catalog<String>("lineWidth","label")="Line Width";
	catalog<String>("lineWidth","page")="Display";
	catalog<String>("lineWidth","hint")="Thickness of box lines.";

	catalog<I32>("rimSize")=4;
	catalog<I32>("rimSize","min")=2;
	catalog<I32>("rimSize","max")=10;
	catalog<String>("rimSize","label")="Rim Size";
	catalog<String>("rimSize","page")="Display";
	catalog<String>("rimSize","hint")="Width of boxes.";

	catalog< sp<Component> >("Brush");
	catalog<String>("Brush","implementation")="DrawI";
	catalog<String>("Brush","visible")="any";
	catalog<String>("Brush","prompt")=
			"LMB selects/moves/paints."
			"  MMB creates/unpaints."
			"  ESC deselects."
			"  DEL hides."
			"  ctrl-DEL reverts."
			"  Enter toggles area-select."
			"  shift-MMB resizes area."
			"  ctrl-shift-MMB adjusts falloff."
			"  WHEEL picks paint action."
			"  ctrl-paint floods.";

	catalog< sp<Component> >("Input Surface");

	catalog< sp<Component> >("Driver Surface");

	//* TODO reuse would need to be able to delete points from mesh
//	catalog<bool>("Output Surface","recycle")=true;

	m_spWireframe=new DrawMode();
	m_spWireframe->setDrawStyle(DrawMode::e_wireframe);
	m_spWireframe->setPointSize(2.0);
	m_spWireframe->setLineWidth(2.0);

	m_spSolid=new DrawMode();
	m_spSolid->copy(m_spWireframe);
	m_spSolid->setDrawStyle(DrawMode::e_solid);
	m_spSolid->setLit(FALSE);
	m_spSolid->setBackfaceCulling(FALSE);

	m_spForeshadow=new DrawMode();
	m_spForeshadow->copy(m_spSolid);
	m_spForeshadow->setDrawStyle(DrawMode::e_foreshadow);
	m_spForeshadow->setAntialias(TRUE);
	m_spForeshadow->setLayer(1);

	m_spBehind=new DrawMode();
	m_spBehind->copy(m_spSolid);
	m_spBehind->setLayer(-1);
}

void FollicleOp::handle(Record& a_rSignal)
{
	const String modifyMode=catalog<String>("modifyMode");
	const SpatialVector replacement=catalog<SpatialVector>("replacement");
	const SpatialVector mask=catalog<SpatialVector>("mask");
	const Real scalar=catalog<Real>("scalar");
	const Real opacity=catalog<Real>("opacity");
	const Real singleRadius=catalog<Real>("singleRadius");
	const Real fuzzy=catalog<Real>("fuzzy");

	String& rAction=catalog<String>("action");
	Real& rPickRadius=catalog<Real>("pickRadius");
	Real& rFalloff=catalog<Real>("falloff");

	const I32 lineWidth=catalog<I32>("lineWidth");
	const I32 rimSize=catalog<I32>("rimSize");

	const BWORD affectAttribute=catalog<bool>("affectAttribute");
	const String attribute=catalog<String>("attribute");

	sp<DrawI> spDrawBrush;
	accessBrush(spDrawBrush,a_rSignal,e_quiet);

	sp<DrawI> spDrawOverlay;
	accessBrushOverlay(spDrawOverlay,a_rSignal,e_quiet);

#if FE_FCO_DEBUG
	feLog("FollicleOp::handle brush %d brushed %d\n",
			spDrawBrush.isValid(),m_brushed);
#endif

	if(spDrawBrush.isValid())
	{
		m_spWireframe->setLineWidth(lineWidth);

		spDrawBrush->pushDrawMode(m_spForeshadow);
		spDrawOverlay->pushDrawMode(m_spSolid);

		m_brushed=TRUE;

		const Real foreAlpha=0.5;
		const Color black(0.0,0.0,0.0);
		const Color white(1.0,1.0,0.8);
		const Color grey(0.8,0.8,1.0);
		const Color red(0.8,0.0,0.0);
		const Color green(0.0,0.5,0.0);
		const Color blue(0.0,0.0,1.0);
		const Color cyan(0.0,1.0,1.0);
		const Color magenta(0.8,0.0,0.8);
		const Color yellow(1.0,1.0,0.0,foreAlpha);
		const Color sparkle(1.0,1.0,0.6);
		const Color orange(1.0,0.5,0.0,foreAlpha);
		const Color blank(0.0,0.0,0.0,0.0);

		const SpatialVector up(0.0,1.0,0.0);

		/***
			available: left middle wheel shift ctrl esc return del

			[] = TODO

			Drag Mode:

			select/move				Left, Drag
			unselect				Esc or click off object
			create					Middle
			hide selection			Del
			revert					ctrl-Del
			toggle-select			ctrl-single [rm]
			also-select				[shift-Left]
			unselect				[ctrl-Left]
			multi-select			shift-area + drag
			include hidden			shift-ctrl

			Paint Mode:

			rotate operation		Wheel

			replace/restore			Left/Middle
			smooth/saturate
			add/subtract
			scale/invScale

			[flood/altFlood]		[ctrl-Left/ctrl-Middle]

			Any Mode:

			toggle single/area		Enter

			area radius				shift-Middle
			soft falloff			shift-ctrl-Middle
			fuzzy-select			Noise-Weighting

			soft-select and area-select are dot-aligned

			soft available in area mode
			fuzzy is parameter of soft

			inner box - selected (color by weight)
			outline box - to select
		*/

		sp<ViewI> spView=spDrawOverlay->view();
		sp<ViewMode> spViewMode=spView->viewMode();
		const Box2i viewport=spViewMode->viewport();
		const I32 viewHeight=viewport.size()[1];

		if(m_spDriver.isValid())
		{
			const SpatialVector& rRayOrigin=rayOrigin(a_rSignal);
			const SpatialVector& rRayDirection=rayDirection(a_rSignal);

			m_event.bind(windowEvent(a_rSignal));

#if FE_FCO_DEBUG
			feLog("%s\n",c_print(m_event));
#endif

			SpatialVector intersection;
			set(intersection);
			SpatialVector hitNormal;
			set(hitNormal);
			BWORD impacted=FALSE;

			const Real maxDistance=100.0;
			sp<SurfaceI::ImpactI> spImpact=m_spDriver->rayImpact(
					rRayOrigin,rRayDirection,maxDistance);
			if(spImpact.isValid())
			{
				sp<SurfaceTriangles::Impact> spTriImpact=spImpact;
				if(spTriImpact.isValid())
				{
					intersection=spTriImpact->intersection();
					hitNormal=spTriImpact->normal();
#if FE_FCO_DEBUG
					const I32 face=spTriImpact->face();
					const I32 pickIndex=spTriImpact->triangleIndex();
					feLog("FollicleOp::handle face %d pick %d %s\n",
							face,pickIndex,c_print(intersection));
#endif

					impacted=TRUE;
				}
			}

			SpatialTransform camera=spViewMode->camera();
			SpatialTransform invCamera;
			invert(invCamera,camera);

			const SpatialVector deltaX=invCamera.column(0);
			const SpatialVector deltaY=invCamera.column(1);

			I32 closest= -1;
			Real closestDist= -1.0;

			const I32 outputCount=m_spOutputPoint->count();
			m_colorRim.resize(outputCount);
			m_colorCenter.resize(outputCount);

			std::set<I32> hiddenSet;

			sp<RecordArray> spRA=m_spState->getArray("Hide");
			if(spRA.isValid())
			{
				for(int i=0;i<spRA->length();i++)
				{
					const I32 pointIndex=m_aIndex(spRA,i);
					hiddenSet.insert(pointIndex);
				}
			}

			U32 item=m_event.item();
			BWORD shifted=FALSE;
			if(item&WindowEvent::e_keyShift)
			{
				shifted=TRUE;
				item^=WindowEvent::e_keyShift;
			}
			BWORD ctrled=FALSE;
			if(item&WindowEvent::e_keyControl)
			{
				ctrled=TRUE;
				item^=WindowEvent::e_keyControl;
			}

			const WindowEvent::MouseButtons buttons=m_event.mouseButtons();
			const BWORD updateCenter=
					!(shifted && (buttons&WindowEvent::e_mbMiddle));

			if(updateCenter)
			{
				const Real extent=rPickRadius;
				const Real extent2=extent*extent;
				for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
				{
					m_colorCenter[pointIndex]=blank;

					const SpatialVector normal=
							m_spOutputNormal->spatialVector(pointIndex);
					const Real hitDot=dot(normal,invCamera.column(2));
					if(hitDot<0)
					{
						m_colorRim[pointIndex]=blank;
						continue;
					}

					m_colorRim[pointIndex]=green;

					if(spImpact.isValid())
					{
						const SpatialVector point=
								m_spOutputPoint->spatialVector(pointIndex);

						const Real dist2=magnitudeSquared(point-intersection);
						if(dist2<extent2)
						{
							const Real dist=sqrt(dist2);

							if(m_areaSelect)
							{
								Real weight=1.0;

								const Real innerRadius=
										rPickRadius*(1.0-rFalloff);

								if(rFalloff>0.0 && dist>innerRadius)
								{
									weight-=(dist-innerRadius)/
											(rFalloff*rPickRadius);
								}

								if(fuzzy)
								{
									weight-=randomReal(0.0,fuzzy);
								}

								m_colorRim[pointIndex]=m_areaSelect?
										Color(0.0,0.0,weight,1.0): blue;
							}

							//* hidden ignored unless ctrl and shift both held
							if((closest<0 || closestDist>dist) &&
								((shifted && ctrled) ||
								hiddenSet.find(pointIndex)==hiddenSet.end()))
							{
								closest=pointIndex;
								closestDist=dist;
							}
						}
					}
				}
				if(!m_areaSelect && closest>=0)
				{
					m_colorRim[closest]=blue;
				}
			}

#if FALSE
			spDrawBrush->pushDrawMode(m_spSolid);
			spDrawBrush->draw(m_spDriver,&white);
			spDrawBrush->popDrawMode();
#endif

			if(m_event.isKeyPress(WindowEvent::e_itemAny))
			{

				if(item==WindowEvent::e_keyCarriageReturn)
				{
					m_areaSelect=!m_areaSelect;
				}

				if(modifyMode=="drag")
				{
					if(item==WindowEvent::e_keyEscape)
					{
						m_pickArray.clear();
					}

					if(item==WindowEvent::e_keyDelete)
					{
						const I32 pickCount=m_pickArray.size();
						for(I32 pickIndex=0;pickIndex<pickCount;pickIndex++)
						{
							const Pick& rPick=m_pickArray[pickIndex];
							const I32 pointIndex=rPick.m_elementId;

							if(shifted)
							{
								hideToggle(pointIndex);
							}
							else
							{
								revert(pointIndex);
							}
						}
						m_pickArray.clear();
					}
				}
			}

			spRA=m_spState->getArray("Hide");
			if(spRA.isValid())
			{
				for(int i=0;i<spRA->length();i++)
				{
					const I32 pointIndex=m_aIndex(spRA,i);
					hiddenSet.insert(pointIndex);
				}
			}

			//* drag mode left click
			if(modifyMode=="drag" && !m_dragging &&
					m_event.isMouseRelease(WindowEvent::e_itemLeft))
			{
				if(closest>=0)
				{
					if(ctrled)
					{
						//* NOTE can ctrl-shift-pick hidden
						if(shifted ||
								hiddenSet.find(closest)==hiddenSet.end())
						{
							pickToggle(closest);
						}
					}
					else if(picked(closest)<1.0)
					{
						if(!shifted)
						{
							m_pickArray.clear();
						}
						if(m_areaSelect)
						{
							for(I32 pointIndex=0;pointIndex<outputCount;
									pointIndex++)
							{
								//* HACK using color for region check
								if(m_colorRim[pointIndex][2]>0.0 &&
										hiddenSet.find(pointIndex)==
										hiddenSet.end())
								{
									pick(pointIndex,m_colorRim[pointIndex][2]);
								}
							}
						}
						if(hiddenSet.find(closest)==hiddenSet.end())
						{
							pick(closest,1.0);
						}
					}
				}
				else if(!ctrled)
				{
					m_pickArray.clear();
				}
#if FE_FCO_EDIT_DEBUG
				feLog("FollicleOp::handle pickArray");
				const I32 pickCount=m_pickArray.size();
				for(I32 pickIndex=0;pickIndex<pickCount;pickIndex++)
				{
					const Pick& rPick=m_pickArray[pickIndex];
					const I32 pointIndex=rPick.m_elementId;
					const Real pointWeight=rPick.m_weight;
					feLog(" %d:%.2f",pointIndex,pointWeight);
				}
				feLog("\n");
#endif
			}

			if(m_event.isMouseWheel())
			{
				m_addWheel+=(m_event.state()>0)? 1: -1;
				updateAction(rAction);
			}

			if(buttons)
			{
				//* TODO screen aware
				const Real moveScale=3e-3;

				const I32 mouseX=m_event.mouseX();
				const I32 mouseY=m_event.mouseY();

				const I32 moveX=mouseX-m_lastX;
				const I32 moveY=mouseY-m_lastY;

				const Vector2 uv=spImpact.isValid()?
						spImpact->uv(): Vector2(0.0,0.0);

				const BWORD snapUV=(catalog<String>("snapMode")=="uv");

#if FALSE
				//* TODO use last UV to current UV
				const Real uvScale=0.3;

				const SpatialVector deltaP=
						moveScale*(deltaX*moveX+deltaY*moveY);

				const SpatialVector du=spImpact->du();
				const SpatialVector dv=spImpact->dv();
				const SpatialVector delta=snapUV?
						uvScale*SpatialVector(dot(deltaP,du),dot(deltaP,dv)):
						deltaP;
#else
				const SpatialVector delta=snapUV?
						SpatialVector(uv-m_lastUV):
						moveScale*(deltaX*moveX+deltaY*moveY);
#endif

				if(shifted && (buttons&WindowEvent::e_mbMiddle))
				{
					//* TODO smart increment scale

					if(m_event.isMouseDrag())
					{
						if(ctrled)
						{
							m_addFalloff+=0.01*moveX;

							if(m_addFalloff<-rFalloff)
							{
								m_addFalloff=-rFalloff;
							}
							else if(m_addFalloff>1.0-rFalloff)
							{
								m_addFalloff=1.0-rFalloff;
							}
						}
						else
						{
							m_addRadius+=0.01*moveX;

							if(m_addRadius<-rPickRadius)
							{
								m_addRadius=-rPickRadius;
							}
						}
					}
				}
				else if(modifyMode=="drag")
				{
					if(buttons&WindowEvent::e_mbLeft)
					{
						if(m_event.isMouseDrag())
						{
							if(closest>=0)
							{
								movePicked(delta);
							}
						}
					}

					if(buttons&WindowEvent::e_mbMiddle)
					{
						if(impacted && m_event.isMousePress())
						{
							addFollicle(intersection);
						}
					}
				}
				else if(modifyMode=="paint")
				{
					if(closest>=0)
					{
						const BWORD flood=ctrled;

						if(rAction=="replace")
						{
							if(buttons&WindowEvent::e_mbLeft)
							{
								paintValue(scalar*replacement,
										opacity*mask,flood);
							}
							else if(buttons&WindowEvent::e_mbMiddle)
							{
								restoreValue(opacity*mask,flood);
							}
						}
						else if(rAction=="smooth")
						{
							if(buttons&WindowEvent::e_mbLeft)
							{
								smoothValue(opacity*mask,flood);
//								convergeValue(opacity*mask,flood);
							}
							else if(buttons&WindowEvent::e_mbMiddle)
							{
								divergeValue(opacity*mask,flood);
							}
						}
						else if(rAction=="add")
						{
							if(buttons&WindowEvent::e_mbLeft)
							{
								addValue(scalar*replacement,
										opacity*mask,flood);
							}
							else if(buttons&WindowEvent::e_mbMiddle)
							{
								addValue(-scalar*replacement,
										opacity*mask,flood);
							}
						}
						else if(rAction=="scale")
						{
							if(buttons&WindowEvent::e_mbLeft)
							{
								scaleValue(scalar,opacity*mask,flood);
							}
							else if(buttons&WindowEvent::e_mbMiddle)
							{
								if(scalar>0.0)
								{
									scaleValue(1.0/scalar,opacity*mask,flood);
								}
							}
						}
					}
				}

				m_lastX=mouseX;
				m_lastY=mouseY;
				m_lastUV=uv;
				m_dragging=m_event.isMouseDrag();
			}

			if(updateCenter)
			{
				m_pickPoint=intersection;
				m_pickNormal=hitNormal;
			}

			//* TODO param
			const Real mapX=8.0;
			const Real mapY=64.0;
			const Real mapScale=128.0;

			const Real circleRadius=3.0;
			const SpatialVector circleScale(
					circleRadius,circleRadius,circleRadius);

			SpatialTransform circleTransform;
			setIdentity(circleTransform);

			if(impacted)
			{
				const Real offset=0.01;	//TODO param
				const I32 depth=0;

				const SpatialVector center=m_pickPoint+offset*m_pickNormal;

				if(m_areaSelect)
				{
					const Real newPickRadius=rPickRadius+m_addRadius;
					const Real newFalloff=rFalloff+m_addFalloff;

					if(newFalloff>0.0)
					{
						drawPicker(spDrawBrush,center,up,m_pickNormal,
								newPickRadius,depth,&orange);
					}

					drawPicker(spDrawBrush,center,up,m_pickNormal,
							newPickRadius*(1.0-0.99*newFalloff),
							depth,&yellow);
				}
				else
				{
					drawPicker(spDrawBrush,center,up,m_pickNormal,
							singleRadius,depth,&yellow);
				}

				const Vector2 uv=spImpact->uv();
				const SpatialVector pixel(mapX+mapScale*uv[0],
						mapY+mapScale*uv[1]);

				setTranslation(circleTransform,pixel);
				spDrawOverlay->drawCircle(circleTransform,&circleScale,magenta);
			}

			const BWORD realValue=(m_attributeType=="real");
			const BWORD vectorValue=m_attributeType.match("vector.");

			spRA=m_spState->getArray("Hide");
			if(spRA.isValid())
			{
				for(int i=0;i<spRA->length();i++)
				{
					const I32 pointIndex=m_aIndex(spRA,i);

					const SpatialVector point=
							m_spInputPoint->spatialVector(pointIndex);
					sp<SurfaceI::ImpactI> spImpact=
							m_spDriver->nearestPoint(point);
					if(!spImpact.isValid())
					{
						continue;
					}

					const Vector2 uv=spImpact->uv();
					const SpatialVector pixel(mapX+mapScale*uv[0],
							mapY+mapScale*uv[1]);

					spDrawOverlay->drawPoints(&pixel,NULL,1,FALSE,&red);
				}
			}

			spRA=m_spState->getArray("Move");
			if(spRA.isValid())
			{
				for(int i=0;i<spRA->length();i++)
				{
					const I32 pointIndex=m_aIndex(spRA,i);
					if(pointIndex<0 || pointIndex>=outputCount)
					{
						continue;
					}

					if(modifyMode=="paint")
					{
						const SpatialVector value=m_aValue(spRA,i);

						Color color(1.0,1.0,1.0);

						if(realValue)
						{
							set(color,1.0,value[0],0.0);
						}
						else if(vectorValue)
						{
							set(color,value[0],value[1],value[2]);
						}

						m_colorCenter[pointIndex]=color;
					}

					const BWORD isHidden=
							(hiddenSet.find(pointIndex)!=hiddenSet.end());
					if(!isHidden)
					{
						const SpatialVector point=
								m_spInputPoint->spatialVector(pointIndex);
						sp<SurfaceI::ImpactI> spImpact=
								m_spDriver->nearestPoint(point);
						if(!spImpact.isValid())
						{
							continue;
						}

						const Vector2 uv=spImpact->uv();
						const SpatialVector pixel(mapX+mapScale*uv[0],
								mapY+mapScale*uv[1]);

						spDrawOverlay->drawPoints(&pixel,NULL,1,FALSE,&blue);
					}
				}
			}

			if(m_spOutputAttribute.isValid())
			{
				spDrawBrush->pushDrawMode(m_spSolid);

				Array<SpatialVector> locationArray(outputCount);
				Array<SpatialVector> normalArray(outputCount);
				Array<Vector2> uvArray(outputCount);
				Array<Vector2> pixelArray(outputCount);
				Array<Color> colorArray(outputCount);

				const I32 inputCount=m_spInputPoint->count();
				U32 visibleCount=0;

				for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
				{
					const BWORD isHidden=
							(hiddenSet.find(pointIndex)!=hiddenSet.end());
					if(isHidden)
					{
						continue;
					}

					const SpatialVector point=
							m_spOutputPoint->spatialVector(pointIndex);

					//* TODO read UV attribute (also need to update those uvs)
					sp<SurfaceI::ImpactI> spImpact=
							m_spDriver->nearestPoint(point);
					if(!spImpact.isValid())
					{
						continue;
					}

					const Vector2 uv=spImpact->uv();
					const SpatialVector pixel(mapX+mapScale*uv[0],
							mapY+mapScale*uv[1]);

					Color sampleColor(1.0,1.0,1.0);

					if(realValue)
					{
						const Real value1=
								m_spOutputAttribute->real(pointIndex);
						set(sampleColor,value1,value1,value1);
					}
					else if(vectorValue)
					{
						const SpatialVector value3=
								m_spOutputAttribute->spatialVector(pointIndex);
						set(sampleColor,value3[0],value3[1],value3[2]);
					}

					spDrawOverlay->drawPoints(&pixel,NULL,1,FALSE,
							pointIndex<inputCount? &cyan: &orange);

					locationArray[visibleCount]=spImpact->intersection();
					normalArray[visibleCount]=spImpact->normal();
					uvArray[visibleCount]=uv;
					pixelArray[visibleCount]=pixel;
					colorArray[visibleCount]=sampleColor;
					visibleCount++;
				}

				locationArray.resize(visibleCount);
				normalArray.resize(visibleCount);
				uvArray.resize(visibleCount);
				pixelArray.resize(visibleCount);
				colorArray.resize(visibleCount);

				spDrawOverlay->pushDrawMode(m_spBehind);

				//* Delaunay
				Array<Vector3i> triangleArray;
				PointConnect::solve(uvArray,triangleArray);

				const U32 primitiveCount=triangleArray.size();
				for(U32 primitiveIndex=0;primitiveIndex<primitiveCount;
						primitiveIndex++)
				{
					const Vector3i& rTriangle=triangleArray[primitiveIndex];
					const I32 tri0=rTriangle[0];
					const I32 tri1=rTriangle[1];
					const I32 tri2=rTriangle[2];

					SpatialVector vertex[3];
					vertex[0]=locationArray[tri0];
					vertex[1]=locationArray[tri1];
					vertex[2]=locationArray[tri2];

					SpatialVector vertexNormal[3];
					vertexNormal[0]=normalArray[tri0];
					vertexNormal[1]=normalArray[tri1];
					vertexNormal[2]=normalArray[tri2];

					Color vertexColor[3];
					vertexColor[0]=colorArray[tri0];
					vertexColor[1]=colorArray[tri1];
					vertexColor[2]=colorArray[tri2];

					spDrawBrush->drawTriangles(vertex,vertexNormal,
							NULL,3,DrawI::e_discrete,
							TRUE,vertexColor);

					vertex[0]=pixelArray[tri0];
					vertex[1]=pixelArray[tri1];
					vertex[2]=pixelArray[tri2];

					set(vertexNormal[0],0.0,0.0,1.0);
					set(vertexNormal[1],0.0,0.0,1.0);
					set(vertexNormal[2],0.0,0.0,1.0);

					spDrawOverlay->drawTriangles(vertex,vertexNormal,
							NULL,3,DrawI::e_discrete,
							TRUE,vertexColor);
				}

				spDrawOverlay->popDrawMode();

				spDrawBrush->popDrawMode();
			}

			//* TODO more selective
			catalog<String>("Brush","cook")="once";
		}

		const I32 outputCount=m_spOutputPoint->count();
		if(modifyMode=="drag")
		{
			const I32 pickCount=m_pickArray.size();
			for(I32 pickIndex=0;pickIndex<pickCount;pickIndex++)
			{
				const Pick& rPick=m_pickArray[pickIndex];
				const I32 pointIndex=rPick.m_elementId;
				const Real pointWeight=rPick.m_weight;
				if(pointIndex>=0 && pointIndex<outputCount)
				{
					m_colorCenter[pointIndex]=Color(1.0,pointWeight,0.0,1.0);
				}
			}
		}

		sp<RecordArray> spRA=m_spState->getArray("Hide");
		if(spRA.isValid())
		{
			for(int i=0;i<spRA->length();i++)
			{
				const I32 pointIndex=m_aIndex(spRA,i);
				if(pointIndex>=0 && pointIndex<outputCount)
				{
					m_colorRim[pointIndex]=red;
				}
			}
		}

		std::set<I32> movedSet;
		spRA=m_spState->getArray("Move");
		if(spRA.isValid())
		{
			for(int i=0;i<spRA->length();i++)
			{
				movedSet.insert(m_aIndex(spRA,i));
			}
		}

		for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
		{
			const Color& rColorCenter=m_colorCenter[pointIndex];
			const Color& rColorRim=m_colorRim[pointIndex];
//			if(rColorCenter[3]<=0.0 && rColorRim[3]<=0.0)
			if(rColorRim[3]<=0.0)
			{
				continue;
			}

			const SpatialVector point=
					m_spOutputPoint->spatialVector(pointIndex);

			const BWORD isMoved=(movedSet.find(pointIndex)!=movedSet.end());

			const Color shadow=cyan;
			drawSquare(spDrawOverlay,point,rimSize,
					rColorCenter,rColorRim, isMoved? &shadow: NULL, NULL);
		}

		const U32 margin=2;

		SpatialVector textPoint(8,viewHeight-100);
		String text;
		text.sPrintf("%s Select",m_areaSelect? "Area": "Single");
		drawLabel(spDrawOverlay,textPoint,
				text,FALSE,margin,white,NULL,&black);

		if(modifyMode=="drag")
		{
			textPoint[1]-=16;
			drawLabel(spDrawOverlay,textPoint,"Drag",FALSE,margin,
					sparkle,NULL,&black);
		}
		else if(modifyMode=="paint")
		{
			textPoint[1]-=16;
			drawLabel(spDrawOverlay,textPoint,"Replace",FALSE,margin,
					rAction=="replace"? sparkle: blue,NULL,&black);

			textPoint[1]-=12;
			drawLabel(spDrawOverlay,textPoint,"Smooth",FALSE,margin,
					rAction=="smooth"? sparkle: blue,NULL,&black);

			textPoint[1]-=12;
			drawLabel(spDrawOverlay,textPoint,"Add",FALSE,margin,
					rAction=="add"? sparkle: blue,NULL,&black);

			textPoint[1]-=12;
			drawLabel(spDrawOverlay,textPoint,"Scale",FALSE,margin,
					rAction=="scale"? sparkle: blue,NULL,&black);
		}

		spRA=m_spState->getArray("Add");
		if(spRA.isValid())
		{
#if FE_FCO_OUTPUT_DEBUG
			feLog("FollicleOp::handle add count %d\n",spRA->length());
#endif

			for(int i=0;i<spRA->length();i++)
			{
				Record edit=spRA->getRecord(i);

				const SpatialVector point=m_aLocation(edit);

				drawSquare(spDrawOverlay,point,rimSize,
						blank,grey,NULL,&sparkle);
			}
		}

		spDrawOverlay->popDrawMode();
		spDrawBrush->popDrawMode();

		return;
	}

	rPickRadius+=m_addRadius;
	rFalloff+=m_addFalloff;

	m_addRadius=0.0;
	m_addFalloff=0.0;

	updateAction(rAction);
	m_addWheel=0;

	sp<SurfaceAccessibleI> spInputAccessible;
	if(!access(spInputAccessible,"Input Surface")) return;

	sp<SurfaceAccessibleI> spOutputAccessible;
	if(!accessOutput(spOutputAccessible,a_rSignal)) return;

	if(!access(m_spInputPoint,spInputAccessible,e_point,e_position)) return;

	if(!access(m_spOutputPoint,spOutputAccessible,e_point,e_position)) return;

	if(!access(m_spOutputNormal,spOutputAccessible,e_point,e_normal)) return;

	access(m_spOutputUV,spOutputAccessible,e_point,e_uv);

	m_attributeType="";
	m_spInputAttribute=NULL;
	m_spOutputAttribute=NULL;
	if(affectAttribute)
	{
		if(!access(m_spInputAttribute,spInputAccessible,e_point,attribute))
		{
			catalog<String>("warning")+=
					"missing point attribute "+attribute+";";
		}
		if(m_spInputAttribute.isValid())
		{
			m_attributeType=m_spInputAttribute->type();
		}

		access(m_spOutputAttribute,spOutputAccessible,
				e_point,attribute,e_quiet);
	}

	const BWORD realValue=(m_attributeType=="real");
	const BWORD vectorValue=m_attributeType.match("vector.");

	const BWORD paramChanged=!m_brushed;
	m_brushed=FALSE;

	if(paramChanged)
	{
		if(!access(m_spPoints,"Input Surface")) return;

		m_neighborTable.clear();

		if(!access(m_spDriver,"Driver Surface")) return;
	}

	//* TODO use
//	const BWORD rebuild=(paramChanged ||
//			catalog<bool>("Output Surface","replaced"));

	if(catalog<bool>("Input Surface","replaced"))
	{
		syncToInput();
	}

	const String hideGroup=catalog<String>("hideGroup");
	if(!hideGroup.empty())
	{
		if(!accessOutput(m_spHideGroup,a_rSignal,
				e_pointGroup,hideGroup)) return;

		const I32 outputCount=m_spOutputPoint->count();

		sp<RecordArray> spRA=m_spState->getArray("Hide");
		if(spRA.isValid())
		{
			for(int i=0;i<spRA->length();i++)
			{
				const I32 pointIndex=m_aIndex(spRA,i);
				if(pointIndex>=0 && pointIndex<outputCount)
				{
					m_spHideGroup->append(pointIndex);
				}
			}
		}

	}

	const I32 pointCount=m_spInputPoint->count();

	sp<RecordArray> spRA=m_spState->getArray("Move");
	if(spRA.isValid())
	{
#if FE_FCO_OUTPUT_DEBUG
		feLog("FollicleOp::handle move count %d\n",spRA->length());
#endif
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);

			if(pointIndex>=pointCount)
			{
				continue;
			}

			Record edit=spRA->getRecord(i);

#if FE_FCO_OUTPUT_DEBUG
			feLog("FollicleOp::handle move %d/%d prim %d/%d\n",
					i,spRA->length(),pointIndex,m_spOutputPoint->count());
#endif

			const SpatialVector original=inputValue(pointIndex);

			//* TODO vector compare of value
			if(magnitudeSquared(m_aLocation(edit))<1e-6 &&
					magnitudeSquared(m_aValue(edit)-original)<1e-6)
			{
				//* remove non-contributing record
				spRA->remove(i);
				i--;
				continue;
			}

			const SpatialVector inputPoint=
					m_spInputPoint->spatialVector(pointIndex);

			const SpatialVector outputPoint=inputPoint+m_aLocation(edit);

			m_spOutputPoint->set(pointIndex,outputPoint);

			if(m_spOutputAttribute.isValid())
			{
				if(realValue)
				{
					m_spOutputAttribute->set(pointIndex,m_aValue(edit)[0]);
				}
				else if(vectorValue)
				{
					m_spOutputAttribute->set(pointIndex,m_aValue(edit));
				}
			}
		}
	}

	sp<DrawI> spOutputDrawI;
	if(!accessDraw(spOutputDrawI,a_rSignal)) return;

	spRA=m_spState->getArray("Add");
	if(spRA.isValid())
	{
#if FE_FCO_OUTPUT_DEBUG
		feLog("FollicleOp::handle append count %d\n",spRA->length());
#endif

		for(int i=0;i<spRA->length();i++)
		{
			Record edit=spRA->getRecord(i);

#if FE_FCO_OUTPUT_DEBUG
			const I32 pointIndex=m_aIndex(spRA,i);
			feLog("FollicleOp::handle append %d/%d point %d/%d\n",
					i,spRA->length(),pointIndex,m_spOutputPoint->count());
#endif

			const SpatialVector point=m_aLocation(edit);

			//* add point to output
			spOutputDrawI->drawPoints(&point,NULL,1,FALSE,NULL);
		}
	}

	return;
}

void FollicleOp::updateAction(String& m_rAction)
{
	const String modifyMode=catalog<String>("modifyMode");

	if(m_addWheel && modifyMode=="paint")
	{
		I32 intAction=0;	//* "replace"
		if(m_rAction=="smooth")
		{
			intAction=1;
		}
		if(m_rAction=="add")
		{
			intAction=2;
		}
		if(m_rAction=="scale")
		{
			intAction=3;
		}

		intAction=fe::minimum(fe::maximum(intAction-m_addWheel,0),3);

		switch(intAction)
		{
			case 0:
				m_rAction="replace";
				break;
			case 1:
				m_rAction="smooth";
				break;
			case 2:
				m_rAction="add";
				break;
			case 3:
				m_rAction="scale";
				break;
		}
	}
}

BWORD FollicleOp::revert(I32 a_index)
{
	BWORD result=FALSE;
	if(hidden(a_index))
	{
		hideToggle(a_index);
		result=TRUE;
	}
	sp<RecordArray> spRA=m_spState->getArray("Move");
	if(spRA.isValid())
	{
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);
			if(a_index==pointIndex)
			{
				spRA->remove(i);
				return TRUE;
			}
		}
	}
	return result;
}

void FollicleOp::setValueLimited(Record a_edit,SpatialVector a_value)
{
	//* TODO param min,max

	for(I32 m=0;m<3;m++)
	{
		if(a_value[m]>1.0)
		{
			a_value[m]=1.0;
		}
		if(a_value[m]<0.0)
		{
			a_value[m]=0.0;
		}
	}

	m_aValue(a_edit)=a_value;
}

void FollicleOp::addValue(SpatialVector a_increase,
	SpatialVector a_mask,BWORD a_flood)
{
	const I32 outputCount=m_spOutputPoint->count();
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=m_aValue(edit);

		const SpatialVector newValue(
				oldValue[0]+weightedMask[0]*a_increase[0],
				oldValue[1]+weightedMask[1]*a_increase[1],
				oldValue[2]+weightedMask[2]*a_increase[2]);

		setValueLimited(edit,newValue);
	}
}

void FollicleOp::scaleValue(Real a_scale,SpatialVector a_mask,BWORD a_flood)
{
	const I32 outputCount=m_spOutputPoint->count();
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=m_aValue(edit);

		const SpatialVector newValue(
				oldValue[0]*(1.0+(a_scale-1.0)*weightedMask[0]),
				oldValue[1]*(1.0+(a_scale-1.0)*weightedMask[1]),
				oldValue[2]*(1.0+(a_scale-1.0)*weightedMask[2]));

		setValueLimited(edit,newValue);
	}
}

void FollicleOp::paintValue(SpatialVector a_replacement,
		SpatialVector a_mask,BWORD a_flood)
{
	const I32 outputCount=m_spOutputPoint->count();
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=m_aValue(edit);

		const SpatialVector newValue(
				(1.0-weightedMask[0])*oldValue[0]+
				weightedMask[0]*a_replacement[0],
				(1.0-weightedMask[1])*oldValue[1]+
				weightedMask[1]*a_replacement[1],
				(1.0-weightedMask[2])*oldValue[2]+
				weightedMask[2]*a_replacement[2]);

		setValueLimited(edit,newValue);
	}
}

void FollicleOp::restoreValue(SpatialVector a_mask,BWORD a_flood)
{
	const I32 outputCount=m_spOutputPoint->count();
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=m_spEditMap->lookup(pointIndex);
		if(!edit.isValid() || !m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=m_aValue(edit);
		const SpatialVector origValue=inputValue(pointIndex);

		const SpatialVector newValue(
				(1.0-weightedMask[0])*oldValue[0]+
				weightedMask[0]*origValue[0],
				(1.0-weightedMask[1])*oldValue[1]+
				weightedMask[1]*origValue[1],
				(1.0-weightedMask[2])*oldValue[2]+
				weightedMask[2]*origValue[2]);

		setValueLimited(edit,newValue);
	}
}

BWORD FollicleOp::calcWeightedAverage(SpatialVector& rAverage,BWORD a_flood)
{
	const I32 outputCount=m_spOutputPoint->count();

	SpatialVector sum(0.0,0.0,0.0);
	Real totalWeight=0.0;
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		sum+=m_aValue(edit)*weight;
		totalWeight+=weight;
	}
	if(totalWeight<=1e-6)
	{
		set(rAverage);
		return FALSE;
	}

	rAverage=sum/totalWeight;
	return TRUE;
}

BWORD FollicleOp::calcLimits(SpatialVector& rMinimum,
		SpatialVector& rMaximum,BWORD a_flood)
{
	const I32 outputCount=m_spOutputPoint->count();

	BWORD found=FALSE;
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector value=m_aValue(edit);

		if(!found)
		{
			rMinimum=value;
			rMaximum=value;
			found=TRUE;
			continue;
		}

		for(I32 m=0;m<3;m++)
		{
			if(rMinimum[m]>value[m])
			{
				rMinimum[m]=value[m];
			}
			if(rMaximum[m]<value[m])
			{
				rMaximum[m]=value[m];
			}
		}
	}

	return found;
}

void FollicleOp::updateNeighbors(void)
{
	const I32 outputCount=m_spOutputPoint->count();

	m_neighborTable.clear();
	m_neighborTable.resize(outputCount);

	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		Array<I32>& rNeighborArray=m_neighborTable[pointIndex];

		if(m_spOutputUV.isNull())
		{
//			feLog("%d/%d no uv\n",pointIndex,outputCount);
			continue;
		}

		const Vector2 uv=m_spOutputUV->spatialVector(pointIndex);

//		feLog("%d/%d uv %s\n",pointIndex,outputCount,c_print(uv));

		const Real maxDistance= -1.0;
		const I32 hitLimit=8;
		Array< sp<SurfaceI::ImpactI> > impactArray=
				m_spPoints->nearestPoints(uv,maxDistance,hitLimit);

		const U32 impactCount=impactArray.size();
		rNeighborArray.resize(impactCount);

		for(U32 impactIndex=0;impactIndex<impactCount;impactIndex++)
		{
			sp<SurfaceI::ImpactI> spImpact=impactArray[impactIndex];
			const I32 primitiveIndex=spImpact->primitiveIndex();

			rNeighborArray[impactIndex]=primitiveIndex;

//			feLog("%d/%d neighbor %d/%d %d uv %s vs %s\n",
//					pointIndex,outputCount,
//					impactIndex,impactCount,primitiveIndex,
//					c_print(spImpact->uv()),c_print(uv));
		}
	}
}

void FollicleOp::smoothValue(SpatialVector a_mask,BWORD a_flood)
{
	if(!m_neighborTable.size())
	{
		updateNeighbors();
	}

	const BWORD realValue=(m_attributeType=="real");
	const BWORD vectorValue=m_attributeType.match("vector.");

	const I32 outputCount=m_spOutputPoint->count();

	SpatialVector existingValue[outputCount];
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		Record edit=m_spEditMap->lookup(pointIndex);
		if(edit.isValid() && m_aValue.check(edit))
		{
			existingValue[pointIndex]=m_aValue(edit);
			continue;
		}

		if(realValue)
		{
			const Real value1=
					m_spOutputAttribute->real(pointIndex);
			set(existingValue[pointIndex],value1,value1,value1);
		}
		else if(vectorValue)
		{
			existingValue[pointIndex]=
					m_spOutputAttribute->spatialVector(pointIndex);
		}
	}

	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=existingValue[pointIndex];

		SpatialVector sum=oldValue;
		I32 total=1;

		//* TODO distance weighted

		Array<I32>& rNeighborArray=m_neighborTable[pointIndex];
		const I32 neighborCount=rNeighborArray.size();
		for(I32 neighborIndex=0;neighborIndex<neighborCount;neighborIndex++)
		{

			const I32 otherIndex=rNeighborArray[neighborIndex];
			sum+=existingValue[otherIndex];
			total++;

//			feLog("%d other %d/%d %d sum %s total %d\n",
//					pointIndex,neighborIndex,neighborCount,otherIndex,
//					c_print(sum),total);
		}

		const SpatialVector average=sum/Real(total);

		const SpatialVector newValue(
				(1.0-weightedMask[0])*oldValue[0]+
				weightedMask[0]*average[0],
				(1.0-weightedMask[1])*oldValue[1]+
				weightedMask[1]*average[1],
				(1.0-weightedMask[2])*oldValue[2]+
				weightedMask[2]*average[2]);

		setValueLimited(edit,newValue);
	}
}

void FollicleOp::convergeValue(SpatialVector a_mask,BWORD a_flood)
{
	SpatialVector average;
	if(!calcWeightedAverage(average,a_flood))
	{
		return;
	}

//	feLog("FollicleOp::convergeValue sum %.6G total %.6G average %.6G\n",
//			sum,totalWeight,average);

//	sum=0.0;

	const I32 outputCount=m_spOutputPoint->count();
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=m_aValue(edit);

		const SpatialVector newValue(
				(1.0-weightedMask[0])*oldValue[0]+
				weightedMask[0]*average[0],
				(1.0-weightedMask[1])*oldValue[1]+
				weightedMask[1]*average[1],
				(1.0-weightedMask[2])*oldValue[2]+
				weightedMask[2]*average[2]);

		setValueLimited(edit,newValue);
	}

//	feLog("FollicleOp::convergeValue new sum %.6G mean %.6G\n",
//			sum,sum/totalWeight);
}

void FollicleOp::divergeValue(SpatialVector a_mask,BWORD a_flood)
{
	SpatialVector average;
	if(!calcWeightedAverage(average,a_flood))
	{
		return;
	}

	SpatialVector min;
	SpatialVector max;
	if(!calcLimits(min,max,a_flood))
	{
		return;
	}

	SpatialVector scaleFactor(1.0,1.0,1.0);
	for(I32 m=0;m<3;m++)
	{
		if(average[m]>min[m] && average[m]<max[m])
		{
			scaleFactor[m]=fe::maximum(
					(1.0f-average[m])/(max[m]-average[m]),
					(average[m])/(average[m]-min[m]));
		}
	}

	const I32 outputCount=m_spOutputPoint->count();
	for(I32 pointIndex=0;pointIndex<outputCount;pointIndex++)
	{
		const Real weight=a_flood? 1.0: m_colorRim[pointIndex][2];
		if(weight<=0.0)
		{
			continue;
		}

		Record edit=getEdit(pointIndex);
		if(!m_aValue.check(edit))
		{
			continue;
		}

		const SpatialVector weightedMask=weight*a_mask;

		const SpatialVector oldValue=m_aValue(edit);

		SpatialVector newValue;

		for(I32 m=0;m<3;m++)
		{
			newValue[m]=(1.0-weightedMask[m])*oldValue[m]+weightedMask[m]*
					(average[m]+scaleFactor[m]*(oldValue[m]-average[m]));
		}

		setValueLimited(edit,newValue);
	}
}

SpatialVector FollicleOp::inputValue(I32 a_pointIndex)
{
	SpatialVector original(0.0,0.0,0.0);

	if(m_spInputAttribute.isValid())
	{
		if(m_attributeType=="real")
		{
			original[0]=m_spInputAttribute->real(a_pointIndex);
		}
		else if(m_attributeType.match("vector."))
		{
			original=m_spInputAttribute->spatialVector(a_pointIndex);
		}
	}

	return original;
}

BWORD FollicleOp::hideToggle(I32 a_index)
{
	sp<RecordArray> spRA=m_spState->getArray("Hide");
	if(spRA.isValid())
	{
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);
			if(a_index==pointIndex)
			{
				spRA->remove(i);
				return TRUE;
			}
		}
	}

	hide(a_index);
	return FALSE;
}

void FollicleOp::hide(I32 a_index)
{
	//* remove if point was an add
	sp<RecordArray> spRA=m_spState->getArray("Add");
	if(spRA.isValid())
	{
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);
			if(a_index==pointIndex)
			{
				spRA->remove(i);
//				Record record=spRA->getRecord(i);
//				m_spState->remove(record);
				return;
			}
		}
	}
	//* no change if already hidden
	spRA=m_spState->getArray("Hide");
	if(spRA.isValid())
	{
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);
			if(a_index==pointIndex)
			{
				return;
			}
		}
	}
	Record hide=m_spScope->createRecord("Hide");
	m_aIndex(hide)=a_index;

	m_spState->add(hide);
}

//* NOTE slow search
BWORD FollicleOp::hidden(I32 a_index)
{
	sp<RecordArray> spRA=m_spState->getArray("Hide");
	if(spRA.isValid())
	{
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);
			if(a_index==pointIndex)
			{
				return TRUE;
			}
		}
	}
	return FALSE;
}

//* NOTE slow search
BWORD FollicleOp::moved(I32 a_index)
{
	sp<RecordArray> spRA=m_spState->getArray("Move");
	if(spRA.isValid())
	{
		for(int i=0;i<spRA->length();i++)
		{
			const I32 pointIndex=m_aIndex(spRA,i);
			if(a_index==pointIndex)
			{
				return TRUE;
			}
		}
	}
	return FALSE;
}

Record FollicleOp::getEdit(I32 a_index)
{
	Record edit=m_spEditMap->lookup(a_index);
	if(!edit.isValid())
	{
		edit=m_spScope->createRecord("Move");
		m_aIndex(edit)=a_index;
		m_aSyncLocation(edit)=m_spInputPoint->spatialVector(a_index);
		m_aValue(edit)=inputValue(a_index);

		m_spState->add(edit);

//		feLog("FollicleOp::getEdit %d created\n",a_index);
	}

	return edit;
}

void FollicleOp::addFollicle(const SpatialVector& a_intersection)
{
	I32 maxIndex=m_spOutputPoint->count();

	const I32 pickCount=m_pickArray.size();
	for(I32 pickIndex=0;pickIndex<pickCount;pickIndex++)
	{
		const Pick& rPick=m_pickArray[pickIndex];
		const I32 pointIndex=rPick.m_elementId;
		if(maxIndex<pointIndex)
		{
			maxIndex=pointIndex;
		}
	}

	Record edit=m_spScope->createRecord("Add");
	m_aIndex(edit)=maxIndex;
	m_aLocation(edit)=a_intersection;
	set(m_aValue(edit));

	sp<SurfaceI::ImpactI> spImpact=m_spDriver->nearestPoint(a_intersection);
	m_aUV(edit)=spImpact.isValid()? spImpact->uv(): Vector2(0.0,0.0);

	m_spState->add(edit);

	m_neighborTable.clear();
}

void FollicleOp::movePicked(const SpatialVector& a_rDelta)
{
#if FE_FCO_EDIT_DEBUG
	feLog("FollicleOp::movePicked %s\n",c_print(a_rDelta));
#endif

	const BWORD snapUV=(catalog<String>("snapMode")=="uv");

	const I32 pickCount=m_pickArray.size();
	for(I32 pickIndex=0;pickIndex<pickCount;pickIndex++)
	{
		const Pick& rPick=m_pickArray[pickIndex];
		const I32 pointIndex=rPick.m_elementId;
		const Real pointWeight=rPick.m_weight;
		Record edit=getEdit(pointIndex);
		if(snapUV)
		{
			slideOnUV(pointIndex,a_rDelta*pointWeight);
		}
		else
		{
			m_aLocation(edit)+=a_rDelta*pointWeight;

#if FE_FCO_EDIT_DEBUG
			SpatialVector inputPoint;
			set(inputPoint);
			const U32 inputCount=m_spInputPoint->count();
			if(pointIndex<inputCount)
			{
				inputPoint=m_spInputPoint->spatialVector(pointIndex);
			}

			const SpatialVector outputPoint=inputPoint+m_aLocation(edit);

			feLog("FollicleOp::movePicked %d %d at %s by %s to %s\n",
					pickIndex,pointIndex,c_print(inputPoint),
					c_print(m_aLocation(edit)),c_print(outputPoint));
#endif

			snapToSurface(pointIndex);

#if FE_FCO_EDIT_DEBUG
			feLog("  snap %s\n",c_print(m_aLocation(edit)));
#endif
		}
	}

	m_neighborTable.clear();
}

void FollicleOp::slideOnUV(I32 a_index,const Vector2 a_deltaUV)
{
#if FE_FCO_EDIT_DEBUG
	feLog("FollicleOp::slideOnUV %d %s\n",a_index,c_print(a_deltaUV));
#endif

	const I32 inputCount=m_spInputPoint->count();

	SpatialVector point;
	set(point);

	Vector2 origUV;
	set(origUV);

	if(a_index<inputCount)
	{
		point=m_spInputPoint->spatialVector(a_index);

		sp<SurfaceI::ImpactI> spImpact=m_spDriver->nearestPoint(point);
		if(!spImpact.isValid())
		{
			return;
		}
		origUV=spImpact->uv();
	}

	Record edit=getEdit(a_index);

	m_aUV(edit)+=a_deltaUV;
	Vector2 uv=origUV+m_aUV(edit);

	const SpatialVector sample=m_spDriver->samplePoint(uv);

#if FE_FCO_EDIT_DEBUG
	feLog("  orig %s add %s uv %s\n",
			c_print(origUV),c_print(m_aUV(edit)),c_print(uv));
	feLog("  point %s sample %s\n",
			c_print(point),c_print(sample));
	feLog("  was %s now %s\n",
			c_print(m_aLocation(edit)),c_print(sample-point));
#endif

	m_aLocation(edit)=sample-point;
}

void FollicleOp::snapToSurface(I32 a_index)
{
	const I32 inputCount=m_spInputPoint->count();

	SpatialVector point;
	set(point);
	if(a_index<inputCount)
	{
		point=m_spInputPoint->spatialVector(a_index);
	}

	Record edit=getEdit(a_index);

	sp<SurfaceI::ImpactI> spImpact=
			m_spDriver->nearestPoint(point+m_aLocation(edit));
	if(!spImpact.isValid())
	{
		return;
	}
	const SpatialVector intersection=spImpact->intersection();

	m_aLocation(edit)=intersection-point;
}

void FollicleOp::setupState(void)
{
	//* TODO driver mesh name for UV space

	m_aIndex.populate(m_spScope,"Move","Index");
	m_aSyncLocation.populate(m_spScope,"Move","SyncLocation");
	m_aLocation.populate(m_spScope,"Move","Location");
	m_aUV.populate(m_spScope,"Move","UV");
	m_aValue.populate(m_spScope,"Move","Value");

	m_aIndex.populate(m_spScope,"Add","Index");
	m_aSyncLocation.populate(m_spScope,"Add","SyncLocation");
	m_aLocation.populate(m_spScope,"Add","Location");
	m_aUV.populate(m_spScope,"Add","UV");
	m_aValue.populate(m_spScope,"Add","Value");

	m_aIndex.populate(m_spScope,"Hide","Index");
	m_aSyncLocation.populate(m_spScope,"Hide","SyncLocation");

	m_spEditMap=m_spState->lookupMap(m_aIndex);
}

BWORD FollicleOp::loadState(const String& rBuffer)
{
	const BWORD success=OperatorState::loadState(rBuffer);

	m_spEditMap=m_spState->lookupMap(m_aIndex);

	return success;
}

void FollicleOp::syncToInput(void)
{
	const String syncMode=catalog<String>("syncMode");
	feLog("FollicleOp::syncToInput %s\n",syncMode.c_str());

	const I32 pointCount=m_spInputPoint->count();

	if(syncMode=="index")
	{
		for(I32 pointIndex=0;pointIndex<pointCount;pointIndex++)
		{
			Record edit=m_spEditMap->lookup(pointIndex);
			if(edit.isValid())
			{
				m_aSyncLocation(edit)=
						m_spInputPoint->spatialVector(pointIndex);
			}
		}
	}
	else if(syncMode=="location")
	{
		sp<RecordGroup> spNewState(new RecordGroup());
		std::map<I32,Record> assignment;

		for(RecordGroup::iterator it=m_spState->begin();
				it!=m_spState->end();it++)
		{
			sp<RecordArray>& rspRA= *it;

			if(rspRA.isValid())
			{
				for(int i=0;i<rspRA->length();i++)
				{
					Record edit=rspRA->getRecord(i);

					BWORD adjusting=TRUE;
					while(adjusting)
					{
						const SpatialVector syncLocation=m_aSyncLocation(edit);

						//* find nearest point
						I32 nearestIndex= -1;
						Real nearestSquared=0.0;
						for(I32 pointIndex=0;pointIndex<pointCount;pointIndex++)
						{
							const SpatialVector point=
									m_spInputPoint->spatialVector(pointIndex);
							const Real distanceSquared=
									magnitudeSquared(point-syncLocation);

							//* TODO maximum range

							if(nearestIndex>=0 &&
									nearestSquared<distanceSquared)
							{
								continue;
							}

							//* TODO a later edit should steal the
							//* pointIndex if closer

							//* avoid repeats
							if(assignment.find(pointIndex)!=assignment.end())
							{
								continue;
							}

							nearestIndex=pointIndex;
							nearestSquared=distanceSquared;
						}

//						feLog("record %d index %d -> %d value %s\n",
//								i,m_aIndex(edit),nearestIndex,
//								c_print(m_aValue(edit)));

						m_aIndex(edit)=nearestIndex;
						if(nearestIndex>=0)
						{
							assignment[nearestIndex]=edit;
						}

						spNewState->add(edit);

						adjusting=FALSE;
					}
				}
			}
		}

		m_spState=spNewState;
		m_spEditMap=m_spState->lookupMap(m_aIndex);
	}
}
