/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __ptex_SurfaceAccessiblePtex_h__
#define __ptex_SurfaceAccessiblePtex_h__

namespace fe
{

/**************************************************************************//**
    @brief Ptex Surface Binding

	@ingroup ptex
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessiblePtex:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessiblePtex(void)					{}
virtual							~SurfaceAccessiblePtex(void)				{}

								//* as SurfaceAccessibleI

virtual sp<SurfaceAccessorI>	accessor(Element a_element,String a_name,
										Creation a_create);

virtual sp<SurfaceAccessorI>	accessor(Element a_element,
										Attribute a_attribute,
										Creation a_create);

virtual	BWORD					load(String a_filename,
										sp<Catalog> a_spSettings);

virtual	void					attributeSpecs(
										Array<SurfaceAccessibleI::Spec>&
										a_rSpecs,
										SurfaceAccessibleI::Element
										a_element) const;

	class Texel
	{
		public:
			SpatialVector	m_location;
			Color			m_color;
	};

	protected:

virtual	void					reset(void);

	private:
		Array<Texel>			m_texelArray;
};

} // namespace

#endif /* __ptex_SurfaceAccessiblePtex_h__ */
